diff --git a/hubs/tests/widgets/test_library.py b/hubs/tests/widgets/test_library.py
index 11e4c92..6cb8297 100644
--- a/hubs/tests/widgets/test_library.py
+++ b/hubs/tests/widgets/test_library.py
@@ -1,7 +1,5 @@
 from __future__ import unicode_literals
 
-import json
-
 from hubs.tests import FakeAuthorization, widget_instance
 from . import WidgetTest
 
@@ -12,27 +10,17 @@ class TestLibrary(WidgetTest):
     def test_data_simple(self):
         widget = widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        response = self.check_url('/ralph/%i/json' % widget.idx, user)
-        data = json.loads(response.get_data(as_text=True))
+        response = self.check_url(
+            '/ralph/w/%s/%i/' % (self.plugin, widget.idx), user)
         expected_dict = {
-            "config": {
-                "urls": "ralph/"
-            },
-            "data": {
-                'title': 'Library',
-                "urls": [
-                    "<a href=\"ralph/\">ralph/</a>"
-                ],
-                'edit_mode': False,
-            },
-            "description": None,
-            "hub": "ralph",
-            "id": 52,
-            "index": 51,
-            "left": False,
-            "plugin": "library"
+            "urls": [
+                "<a href=\"ralph/\">ralph/</a>"
+            ],
+            'edit_mode': False,
+            'widget': widget.module,
+            'widget_instance': widget,
         }
-        self.assertDictEqual(data['data'], expected_dict['data'])
+        self.assertDictEqual(response.context, expected_dict)
 
     def test_view_authz(self):
         self._test_view_authz()
diff --git a/hubs/tests/widgets/test_meetings.py b/hubs/tests/widgets/test_meetings.py
index 0ac32a6..6536856 100644
--- a/hubs/tests/widgets/test_meetings.py
+++ b/hubs/tests/widgets/test_meetings.py
@@ -1,7 +1,5 @@
 from __future__ import unicode_literals
 
-import json
-
 from hubs.tests import FakeAuthorization, widget_instance
 from . import WidgetTest
 
@@ -13,10 +11,9 @@ class TestMeetings(WidgetTest):
         team = 'i18n'
         widget = widget_instance(team, self.plugin)
         user = FakeAuthorization('ralph')
-        response = self.check_url('/%s/%i/json' % (team, widget.idx), user)
-        data = json.loads(response.get_data(as_text=True))
-        calendar_name = data['data']['calendar']
-        self.assertIn(team, calendar_name)
+        response = self.check_url(
+            '/%s/w/%s/%i/' % (team, self.plugin, widget.idx), user)
+        self.assertIn(team, response.context["calendar"])
 
     def test_render_simple(self):
         team = 'i18n'
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
index cc576c7..36df575 100644
--- a/hubs/utils/views.py
+++ b/hubs/utils/views.py
@@ -74,13 +74,14 @@ class WidgetConfigError(Exception):
     pass
 
 
-def create_widget_instance(hub, widget, position):
+def create_widget_instance(hub, widget, position, config=None):
     """View helper to instanciate a widget on a hub.
 
     Arguments:
         hub (hubs.models.Hub): Instance of the hub to create the widget in.
         widget (hubs.widgets.base.Widget): Widget to instanciate.
-        position (str): either ``left`` or ``right``.
+        position (str): Either ``left`` or ``right``.
+        config (dict): Initial configuration for the widget.
     """
     widget_instance = Widget(
         hub=hub, plugin=widget.name, index=-1,
@@ -88,28 +89,34 @@ def create_widget_instance(hub, widget, position):
     flask.g.db.add(widget_instance)
     flask.g.db.flush()  # will populate Widget.config
     try:
-        configure_widget_instance(widget_instance)
+        configure_widget_instance(widget_instance, config)
     except WidgetConfigError as e:
         flask.flash(e.args[0], "error")
     else:
         flask.flash("The widget has been added.")
+    # reorder widgets
+    reorder_widgets(hub, widget_instance.left)
+    return widget_instance
 
 
-def configure_widget_instance(widget_instance):
+def configure_widget_instance(widget_instance, widget_config):
     """Configure a widget instance using the request form data.
 
     Arguments:
         widget_instance (hubs.models.Widget): Instance of the widget that is to
             be configured.
+        widget_config (dict): Configuration to apply to the widget.
     """
+    if not widget_config:
+        return
     config = {}
     for param in widget_instance.module.get_parameters():
-        val = flask.request.form.get(param.name)
+        val = widget_config.get(param.name)
         if not val:
             raise WidgetConfigError(
                 'You must provide a value for: %s' % param.name)
         try:
-            config[param.name] = param.validator.from_string(val)
+            config[param.name] = param.validator(val)
         except ValueError as err:
             raise WidgetConfigError('Invalid data provided, error: %s' % err)
     # Updating in-place is not supported, it's a class property.
@@ -119,7 +126,7 @@ def configure_widget_instance(widget_instance):
     widget_instance.config = cur_config
     # Set the visibility parameter.
     try:
-        widget_instance.visibility = flask.request.form["visibility"]
+        widget_instance.visibility = widget_config["visibility"]
     except KeyError:
         pass  # the value is optional.
     # Update the hub's mtime.  TODO: use a SQLAlchemy signal here.
@@ -136,6 +143,27 @@ def configure_widget_instance(widget_instance):
             'if the error persists, please warn an admin')
 
 
+def reorder_widgets(hub, is_left):
+    """Reset widget instances indicies for a hub and a column."""
+    all_widgets = [w for w in hub.widgets if w.left == is_left]
+    for index, widget in enumerate(all_widgets):
+        widget.index = index
+
+
+def move_widget(widget_instance, new_index):
+    """Move a widget instance to a new index in the same column."""
+    all_widgets = [
+        w for w in widget_instance.hub.widgets
+        if w.left == widget_instance.left
+        ]
+    old_index = [w.idx for w in all_widgets].index(widget_instance.idx)
+    # Move the widget in the list
+    all_widgets.insert(new_index, all_widgets.pop(old_index))
+    # Apply indices according to the position in the list
+    for index, widget in enumerate(all_widgets):
+        widget.index = index
+
+
 def authenticated():
     """ Utility function checking if the current auth is set or not."""
     return hasattr(flask.g, 'auth') \
@@ -158,33 +186,43 @@ def login_required(function):
     return decorated_function
 
 
+def check_hub_access(hub, action, json=False):
+    """Check access to the hub for the specified action.
+
+    Raises:
+        :py:class:`werkzeug.exceptions.Forbidden`: The action is denied (403).
+    """
+    try:
+        user = flask.g.user
+    except AttributeError:
+        user = None
+    if not hub.allows(user, action):
+        if action == "view":
+            msg = "This hub is for members only."
+        elif action == "config":
+            msg = "You are not allowed to configure this hub."
+        else:
+            msg = "Access forbidden."
+        if json:
+            response = flask.jsonify({
+                "status": "ERROR", "message": msg, "hub": hub.name,
+                })
+        else:
+            response = flask.render_template(
+                'errors/hub.html', hub=hub, msg=msg,
+                )
+        flask.abort(403, response=flask.make_response(response, 403))
+    return True
+
+
 def require_hub_access(action, url_param="name", json=False):
-    """Check access to the hub for the specified action."""
+    """View decorator to check access to the hub for the specified action."""
     def decorator(function):
         @functools.wraps(function)
         def wrapper(*args, **kwargs):
             hub_name = kwargs[url_param]
             hub = get_hub(hub_name, load_config=True)
-            try:
-                user = flask.g.user
-            except AttributeError:
-                user = None
-            if not hub.allows(user, action):
-                if action == "view":
-                    msg = "This hub is for members only."
-                elif action == "config":
-                    msg = "You are not allowed to configure this hub."
-                else:
-                    msg = "Access forbidden."
-                if json:
-                    result = flask.jsonify({
-                        "status": "ERROR", "message": msg, "hub": hub.name,
-                        })
-                else:
-                    result = flask.render_template(
-                        'errors/hub.html', hub=hub, msg=msg,
-                        )
-                return result, 403
+            check_hub_access(hub, action, json)
             return function(*args, **kwargs)
         return wrapper
     return decorator
diff --git a/hubs/views/__init__.py b/hubs/views/__init__.py
index 33b68f2..4ea49ec 100644
--- a/hubs/views/__init__.py
+++ b/hubs/views/__init__.py
@@ -4,6 +4,5 @@ from __future__ import absolute_import
 
 from .root import *
 from .hub import *
-from .widget import *
 from .user import *
 from .api import *
diff --git a/hubs/views/api/__init__.py b/hubs/views/api/__init__.py
new file mode 100644
index 0000000..5375623
--- /dev/null
+++ b/hubs/views/api/__init__.py
@@ -0,0 +1,7 @@
+from __future__ import absolute_import
+
+# flake8: noqa
+
+from .hub_association import *
+from .hub_config import *
+from .hub_widget import *
diff --git a/hubs/views/api/hub_association.py b/hubs/views/api/hub_association.py
new file mode 100644
index 0000000..9b5e8ba
--- /dev/null
+++ b/hubs/views/api/hub_association.py
@@ -0,0 +1,80 @@
+from __future__ import absolute_import
+
+import logging
+
+import flask
+
+import hubs.models
+from hubs.app import app
+from hubs.utils.views import get_hub, login_required
+
+log = logging.getLogger(__name__)
+
+
+@app.route('/api/hubs/<hub>/subscribe', methods=['POST'])
+@login_required
+def api_hub_subscribe(hub):
+    hub = get_hub(hub)
+    user = hubs.models.User.by_username(flask.g.auth.nickname)
+    hub.subscribe(user)
+    flask.g.db.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+
+@app.route('/api/hubs/<hub>/unsubscribe', methods=['POST'])
+@login_required
+def api_hub_unsubscribe(hub):
+    hub = get_hub(hub)
+    user = hubs.models.User.by_username(flask.g.auth.nickname)
+    try:
+        hub.unsubscribe(user)
+    except KeyError:
+        return flask.abort(400)
+    flask.g.db.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+
+@app.route('/api/hubs/<hub>/star', methods=['POST'])
+@login_required
+def api_hub_star(hub):
+    hub = get_hub(hub)
+    user = hubs.models.User.by_username(flask.g.auth.nickname)
+    hub.subscribe(user, role='stargazer')
+    flask.g.db.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+
+@app.route('/api/hubs/<hub>/unstar', methods=['POST'])
+@login_required
+def api_hub_unstar(hub):
+    hub = get_hub(hub)
+    user = hubs.models.User.by_username(flask.g.auth.nickname)
+    try:
+        hub.unsubscribe(user, role='stargazer')
+    except KeyError:
+        return flask.abort(400)
+    flask.g.db.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+
+@app.route('/api/hubs/<hub>/join', methods=['POST'])
+@login_required
+def api_hub_join(hub):
+    hub = get_hub(hub)
+    user = hubs.models.User.by_username(flask.g.auth.nickname)
+    hub.subscribe(user, role='member')
+    flask.g.db.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+
+@app.route('/api/hubs/<hub>/leave', methods=['POST'])
+@login_required
+def api_hub_leave(hub):
+    hub = get_hub(hub)
+    user = hubs.models.User.by_username(flask.g.auth.nickname)
+    try:
+        hub.unsubscribe(user, role='member')
+    except KeyError:
+        return flask.abort(400)
+    flask.g.db.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
diff --git a/hubs/views/api/hub_config.py b/hubs/views/api/hub_config.py
new file mode 100644
index 0000000..fa76e29
--- /dev/null
+++ b/hubs/views/api/hub_config.py
@@ -0,0 +1,144 @@
+from __future__ import absolute_import
+
+import logging
+
+import flask
+
+import hubs.models
+from hubs.app import app
+from hubs.utils.views import (
+    get_hub, check_hub_access, RequestValidator, require_hub_access,
+    )
+
+log = logging.getLogger(__name__)
+
+
+class ConfigChangeError(Exception):
+    pass
+
+
+@app.route('/api/hubs/<name>/config', methods=['GET', 'PUT'])
+@require_hub_access("view", json=True)
+def api_hub_config(name):
+    hub = get_hub(name)
+    if flask.request.method == 'PUT':
+        check_hub_access(hub, "config", json=True)
+        request_data = flask.request.get_json()
+        if request_data is None:
+            return flask.jsonify({
+                "status": "ERROR",
+                "message": "No configuration change provided"
+                })
+        try:
+            if request_data.get("config"):
+                result = hub_config_put_config(hub, request_data["config"])
+            if request_data.get("users"):
+                result = hub_config_put_users(hub, request_data["users"])
+        except ConfigChangeError as e:
+            result = e.args[0]
+        else:
+            result = {"status": "OK"}
+        try:
+            flask.g.db.commit()
+        except Exception as err:
+            result = {"status": "ERROR", "message": str(err)}
+        return flask.jsonify(result)
+    result = {"status": "OK", "data": hub.get_props()}
+    return flask.jsonify(result)
+
+
+def hub_config_put_config(hub, config):
+    # Validate values
+    def _validate_chat_domain(value):
+        valid_chat_domains = [
+            network["domain"] for network in app.config["CHAT_NETWORKS"]
+            ]
+        if not value and len(valid_chat_domains) > 0:
+            value = valid_chat_domains[0]
+        if value not in valid_chat_domains:
+            raise ValueError("Unsupported chat domain.")
+        return value
+
+    validator = RequestValidator(dict(
+        # Only allow the parameters listed in __json__().
+        (key, None) for key in hub.config.__json__().keys()
+    ))
+    validator.converters["chat_domain"] = _validate_chat_domain
+    try:
+        values = validator(config)
+    except ValueError as e:
+        result = {"status": "ERROR", "message": "Invalid value(s)"}
+        result["fields"] = e.args[0]
+        raise ConfigChangeError(result)
+
+    # Now set the configuration values.
+    for key, value in values.items():
+        setattr(hub.config, key, value)
+
+
+def hub_config_put_users(hub, user_roles):
+    new_associations = []
+    for role in user_roles:
+        for u in user_roles[role]:
+            new_associations.append((u["username"], role))
+    # Remove old associations
+    for assoc in hub.associations:
+        if assoc.hub != hub:
+            continue
+        try:
+            new_associations.remove(
+                (assoc.user.username, assoc.role))
+        except ValueError:
+            hub.associations.remove(assoc)
+    # Add new associations
+    for assoc in new_associations:
+        username, role = assoc
+        user = hubs.models.User.get(username=username)
+        if user is None:
+            result = {
+                "status": "ERROR",
+                "fields": {"username": "Unknown user"},
+                "message": "Unknown user {}".format(u["username"]),
+                }
+            raise ConfigChangeError(result)
+        hub.associations.append(hubs.models.Association(
+            hub=hub, user=user, role=role))
+    flask.g.db.commit()
+
+
+@app.route('/api/hubs/<name>/config/suggest-users')
+@require_hub_access("config", json=True)
+def api_hub_config_suggest_users(name):
+    MAX_SUGGESTS = 10
+    hub = get_hub(name)
+    results = flask.g.db.query(
+        hubs.models.User.username,
+        hubs.models.User.fullname,
+        )
+    query = flask.request.args.get("q")
+    if query:
+        results = results.filter(
+            hubs.models.User.username.ilike("%{}%".format(query))
+        )
+    exclude = flask.request.args.get("exclude-role")
+    if exclude:
+        exclude_query = flask.g.db.query(
+                hubs.models.User.username
+            ).join(
+                hubs.models.Association
+            ).join(
+                hubs.models.Hub
+            ).filter(
+                hubs.models.Hub.name == hub.name,
+                hubs.models.Association.role == exclude,
+            )
+        results = results.filter(
+            ~hubs.models.User.username.in_(exclude_query)
+            )
+    results = results.order_by(hubs.models.User.username).limit(MAX_SUGGESTS)
+    return flask.jsonify({
+        "status": "OK",
+        "data": [
+            {"username": r[0], "fullname": r[1]} for r in results
+            ],
+        })
diff --git a/hubs/views/api/hub_widget.py b/hubs/views/api/hub_widget.py
new file mode 100644
index 0000000..3ef777d
--- /dev/null
+++ b/hubs/views/api/hub_widget.py
@@ -0,0 +1,111 @@
+from __future__ import absolute_import
+
+import logging
+
+import flask
+from hubs.app import app
+from hubs.widgets import registry
+from hubs.utils.views import (
+    create_widget_instance, configure_widget_instance, get_hub,
+    get_widget_instance, WidgetConfigError,
+    check_hub_access, require_hub_access,
+    move_widget, reorder_widgets,
+    )
+
+log = logging.getLogger(__name__)
+
+
+@app.route('/api/widgets/', methods=['GET'])
+def api_widgets():
+    widgets = []
+    for widget in registry.values():
+        widgets.append(widget.get_props(None))
+    return flask.jsonify({"status": "OK", "data": widgets})
+
+
+@app.route('/api/hubs/<hub>/widgets/', methods=['GET', 'POST'])
+@require_hub_access("view", url_param="hub", json=True)
+def api_hub_widgets(hub):
+    hub = get_hub(hub)
+    try:
+        user = flask.g.user
+    except AttributeError:
+        user = None
+    if flask.request.method == 'POST':
+        check_hub_access(hub, "config", json=True)
+        request_data = flask.request.get_json()
+        try:
+            widget_name = request_data["name"]
+            widget_config = request_data["config"]
+            position = request_data["position"]
+        except KeyError:
+            flask.abort(400, 'Invalid request sent')
+        if position not in ["left", "right"]:
+            flask.abort(400, 'Invalid request sent')
+        available_widgets = [
+            widget.name
+            for widget in registry.values()
+            if widget.position in ['both', position]
+            ]
+        if widget_name not in available_widgets:
+            flask.abort(400, 'Unknown widget')
+        widget = registry[widget_name]
+        create_widget_instance(hub, widget, position, widget_config)
+        flask.g.db.commit()
+        return flask.jsonify({"status": "OK"})
+    user_can_config = hub.allows(user, "config")
+    widgets = []
+    for widget_instance in hub.widgets:
+        if not widget_instance.enabled:
+            continue
+        if not widget_instance.allows(user, "view"):
+            continue
+        widgets.append(widget_instance.get_props(
+            with_secret_config=user_can_config))
+    return flask.jsonify({"status": "OK", "data": widgets})
+
+
+@app.route('/api/hubs/<hub>/widgets/<int:idx>/',
+           methods=['GET', 'PUT', 'DELETE'])
+@require_hub_access("view", url_param="hub", json=True)
+def api_hub_widget(hub, idx):
+    widget_instance = get_widget_instance(hub, idx)
+    hub = widget_instance.hub
+    try:
+        user = flask.g.user
+    except AttributeError:
+        user = None
+    if flask.request.method == "GET":
+        user_can_config = hub.allows(user, "config")
+        result = widget_instance.get_props(with_secret_config=user_can_config)
+        return flask.jsonify({"status": "OK", "data": result})
+    elif flask.request.method == "PUT":
+        check_hub_access(hub, "config", json=True)
+        request_data = flask.request.get_json()
+        widget_config = request_data.get("config", {})
+        try:
+            configure_widget_instance(widget_instance, widget_config)
+        except WidgetConfigError as e:
+            return flask.jsonify({"status": "ERROR", "message": e.args[0]})
+        if "index" in request_data:
+            # Reorder the widgets
+            move_widget(widget_instance, request_data["index"])
+        try:
+            flask.g.db.commit()
+        except Exception as e:
+            msg = "Could not configure this widget: {}".format(e)
+            return flask.jsonify({"status": "ERROR", "message": msg})
+        return flask.jsonify({"status": "OK"})
+    elif flask.request.method == "DELETE":
+        # Remove the widget from the hub.
+        check_hub_access(hub, "config", json=True)
+        is_left = widget_instance.left
+        flask.g.db.delete(widget_instance)
+        try:
+            flask.g.db.commit()
+        except Exception as e:
+            msg = "Could not remove this widget: {}".format(e)
+            return flask.jsonify({"status": "ERROR", "message": msg})
+        reorder_widgets(hub, is_left)
+        return flask.jsonify({"status": "OK"})
+    flask.abort(400)
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index ff52725..6677a7e 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -1,13 +1,11 @@
 from __future__ import unicode_literals, absolute_import
 
-import datetime
 import flask
 import hubs.models
 
 from hubs.app import app
 from hubs.utils.views import (
-    get_hub, get_sse_url, get_visible_widgets, login_required,
-    RequestValidator, require_hub_access,
+    get_hub, get_sse_url, get_menu_entries, get_visible_widgets, require_hub_access,
     )
 
 
@@ -24,269 +22,3 @@ def hub(name):
         edit=False,
         sse_url=get_sse_url("hub/{}".format(hub.name)),
         )
-
-
-@app.route('/<name>/json/')
-@app.route('/<name>/json')
-@require_hub_access("view", json=True)
-def hub_json(name):
-    hub = get_hub(name)
-    response = flask.jsonify(hub.__json__())
-    # TODO -- modify headers with response.headers['X-fedora-hubs-wat'] = 'foo'
-    return response
-
-
-@app.route('/<name>/edit', methods=['GET', 'POST'])
-@login_required
-@require_hub_access("config")
-def hub_edit(name):
-    hub = get_hub(name, load_config=True)
-    if flask.request.method == 'POST':
-        return hub_edit_post(hub)
-    else:
-        return hub_edit_get(hub)
-
-
-def hub_edit_get(hub):
-    widgets = get_visible_widgets(hub)
-    return flask.render_template(
-        'hubs.html',
-        hub=hub,
-        widgets=widgets,
-        edit=True,
-        sse_url=get_sse_url("hub/{}".format(hub.name)),
-        )
-
-
-def hub_edit_post(hub):
-    is_js = flask.request.form.get('js', False)
-
-    error = False
-
-    # Check the input submitted
-    # Right side
-    r_widget_ids = [
-        w.strip().replace('widget-', '')
-        for w in flask.request.form.getlist('right_widgets[]')
-        if w.strip()
-        ]
-    try:
-        r_widget_ids = [int(w) for w in r_widget_ids]
-    except:
-        flask.flash('Invalid widget identifiers submitted', 'error')
-        error = True
-
-    r_indexes = [
-        i.strip() for i in flask.request.form.getlist('right_indexes[]')
-        if i.strip()
-        ]
-
-    try:
-        r_indexes = [int(i) for i in r_indexes]
-    except:
-        if not is_js:
-            flask.flash('Invalid indexes submitted', 'error')
-        error = True
-
-    if len(r_widget_ids) != len(r_indexes):
-        if not is_js:
-            flask.flash(
-                'The number of indexes and the number of widgets are not of '
-                'the same length', 'error')
-        error = True
-
-    # Left side
-    l_widget_ids = [
-        w.strip().replace('widget-', '')
-        for w in flask.request.form.getlist('left_widgets[]')
-        if w.strip()
-        ]
-    try:
-        l_widget_ids = [int(w) for w in l_widget_ids]
-    except:
-        flask.flash('Invalid widget identifiers submitted', 'error')
-        error = True
-
-    l_indexes = [
-        i.strip() for i in flask.request.form.getlist('left_indexes[]')
-        if i.strip()
-        ]
-
-    try:
-        l_indexes = [int(i) for i in l_indexes]
-    except:
-        if not is_js:
-            flask.flash('Invalid indexes submitted', 'error')
-        error = True
-
-    if len(l_widget_ids) != len(l_indexes):
-        if not is_js:
-            flask.flash(
-                'The number of indexes and the number of widgets are not of '
-                'the same length', 'error')
-        error = True
-
-    # If all good, update the database
-    if not error:
-        for cnt, wid in enumerate(r_widget_ids):
-            widget = flask.g.db.query(hubs.models.Widget).get(wid)
-            if widget.index != r_indexes[cnt]:
-                widget.index = r_indexes[cnt]
-                flask.g.db.add(widget)
-        for cnt, wid in enumerate(l_widget_ids):
-            widget = flask.g.db.query(hubs.models.Widget).get(wid)
-            if widget.index != l_indexes[cnt]:
-                widget.index = l_indexes[cnt]
-                flask.g.db.add(widget)
-        hub.last_edited = datetime.datetime.utcnow()
-        flask.g.db.add(hub)
-        try:
-            flask.g.db.commit()
-        except Exception as err:
-            error = True
-            if not is_js:
-                flask.flash(
-                    'Could not save your changes to the database '
-                    'if the error persists, please warn an admin',
-                    'error')
-    if is_js:
-        if error:
-            flask.abort(400)
-        else:
-            return ('ok', 200)
-    else:
-        return flask.redirect(flask.url_for('hub', name=hub.name))
-
-
-@app.route('/<name>/config', methods=['GET', 'POST'])
-@login_required
-@require_hub_access("config", json=True)
-def hub_config(name):
-    hub = get_hub(name)
-    if flask.request.method == 'POST':
-        category = flask.request.args["category"]
-        if category == "config":
-            result = hub_config_post_config(hub)
-        if category == "role_change":
-            result = hub_config_post_role_change(hub)
-        if result is not None:
-            return result
-    result = hub_config_get(hub)
-    return flask.jsonify(result)
-
-
-def hub_config_get(hub):
-    roles = ["owner", "member"]
-    result = {
-        "status": "OK",
-        "result": {
-            "hubconfig": hub.config.__json__(),
-            "general": {
-                "chat_networks": app.config["CHAT_NETWORKS"],
-                "hub_visibility": hubs.models.HubConfig.VISIBILITY,
-                "roles": roles,
-            },
-            "users": {role: [] for role in roles},
-        },
-    }
-    for assoc in sorted(hub.associations, key=lambda a: a.user.username):
-        if assoc.role not in roles:
-            continue
-        user = {
-            "username": assoc.user.username,
-            "fullname": assoc.user.fullname,
-            "role": assoc.role,
-        }
-        if (assoc.role == "owner" and
-                assoc.user.username == flask.g.user.username):
-            user["locked"] = True
-        result["result"]["users"][assoc.role].append(user)
-    return result
-
-
-def hub_config_post_config(hub):
-    # Validate values
-    def _validate_chat_domain(value):
-        valid_chat_domains = [
-            network["domain"] for network in app.config["CHAT_NETWORKS"]
-            ]
-        if not value and len(valid_chat_domains) > 0:
-            value = valid_chat_domains[0]
-        if value not in valid_chat_domains:
-            raise ValueError("Unsupported chat domain.")
-        return value
-
-    validator = RequestValidator(dict(
-        # Only allow the parameters listed in __json__().
-        (key, None) for key in hub.config.__json__().keys()
-    ))
-    validator.converters["chat_domain"] = _validate_chat_domain
-    try:
-        values = validator(flask.request.form)
-    except ValueError as e:
-        result = {"status": "ERROR", "message": "Invalid value(s)"}
-        result["fields"] = e.args[0]
-        return flask.jsonify(result)
-
-    # Now set the configuration values
-    for key, value in values.items():
-        setattr(hub.config, key, value)
-    try:
-        flask.g.db.commit()
-    except Exception as err:
-        result = {"status": "ERROR", "message": str(err)}
-        return flask.jsonify(result)
-
-
-def hub_config_post_role_change(hub):
-    username = flask.request.form["username"]
-    user = hubs.models.User.get(username=username)
-    if user is None:
-        result = {
-            "status": "ERROR",
-            "fields": {"username": "Unknown user"},
-            "message": "Unknown user",
-            }
-        return flask.jsonify(result)
-    role = flask.request.form.get("role")
-    for assoc in hub.associations:
-        if assoc.hub == hub and assoc.user == user:
-            hub.associations.remove(assoc)
-    if role:
-        hub.associations.append(hubs.models.Association(
-            hub=hub, user=user, role=role))
-    flask.g.db.commit()
-
-
-@app.route('/<name>/config/suggest-users')
-@login_required
-@require_hub_access("config", json=True)
-def hub_config_suggest_users(name):
-    MAX_SUGGESTS = 10
-    hub = get_hub(name)
-    results = flask.g.db.query(hubs.models.User.username)
-    query = flask.request.args.get("q")
-    if query:
-        results = results.filter(
-            hubs.models.User.username.ilike("%{}%".format(query))
-        )
-    exclude = flask.request.args.get("exclude-role")
-    if exclude:
-        exclude_query = flask.g.db.query(
-                hubs.models.User.username
-            ).join(
-                hubs.models.Association
-            ).join(
-                hubs.models.Hub
-            ).filter(
-                hubs.models.Hub.name == hub.name,
-                hubs.models.Association.role == exclude,
-            )
-        results = results.filter(
-            ~hubs.models.User.username.in_(exclude_query)
-            )
-    results = results.order_by(hubs.models.User.username).limit(MAX_SUGGESTS)
-    return flask.jsonify({
-        "status": "OK",
-        "results": [r[0] for r in results],
-        })
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 2cecb75..62fe099 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -37,9 +37,9 @@ class BaseView(RootWidgetView):
         context = dict(
             username=username,
             hub_subscribe_url=flask.url_for(
-                'hub_subscribe', hub=instance.hub.name),
+                'api_hub_subscribe', hub=instance.hub.name),
             hub_unsubscribe_url=flask.url_for(
-                'hub_unsubscribe', hub=instance.hub.name),
+                'api_hub_unsubscribe', hub=instance.hub.name),
         )
         get_stats = GetStats(instance)
         context.update(get_stats())
